> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/get-started/faq/2-4-0-migration-guide.md).

# 2.4.0 Migration Guide

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

This guide helps detail what you'll need to do and what has changed. Much of this guide only applies if you have made custom modifications to WebViewer Server.

### The Changes

* WebViewer Server is now composed of 4 files, `embedded-server.jar`,`shared.jar` ,`blackbox.war` ,`demo.war`
* Apache Tomcat is now used as embedded software and configuration is now declared in code. Before we merged our binaries with an Apache Tomcat install.
* To make configuration modifications now, one will need to modify various JAVA\_OPTS on their system or in the container.
* By default, WebViewer Server expects the contents of the `libs` folder 1 level above its working directory. This contains all binaries used in WebViewer Server's operation. This can be configured via TRN\\\_BIN\\\_DIR
* Inside of the Docker Container
  * The root directory is now `/home/tomcat/wv-server`
  * The binary libraries are placed in `/home/tomcat/libs`
* Using the WebViewer Server Windows installer
  * Program execution now occurs in C:/ProgramData/Apryse

**Logging Modifications**

Internally we use *log4j2* to manage our logging, and some customers may use a custom logging file for their setup. In 2.4.0 the way to overwrite this file is to now add this to your JAVA\_OPTS:

Dlog4j.configurationFile=/path/to/log4j2.xml

This document will be updated if there are any more possible migration suggestions, feel free to submit any issues the new release might create for you via support.

\*\*XRef Modifications

\*\*If you are using XRefs in your files, along with an XRef server, you should be aware that the previous path for volume mounting mentioned in our XRef guide has changed. Previously, `/usr/local/apache-tomcat` was the suggested path. Now this directory no longer exists and mounting volumes here may result in permission issues.

You should mount your XRefs under `/home/tomcat` instead now. A path such as `/home/tomcat/xRefFiles` would work here.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/web/get-started/faq/2-4-0-migration-guide.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
